<?php

// {{{ requires
require_once CLASS_EX_REALDIR . 'page_extends/frontparts/bloc/LC_Page_FrontParts_Bloc_Ex.php';

class LC_Page_FrontParts_Bloc_Ranking extends LC_Page_FrontParts_Bloc_Ex
{

    /**
     * Page を初期化する.
     *
     * @return void
     */
    public function init() {
        parent::init();
    }

    /**
     * Page のプロセス.
     *
     * @return void
     */
    public function process() {
        $this->action();
        $this->sendResponse();
    }

    /**
     * Page のアクション.
     *
     * @return void
     */
    public function action() {

        // 会員クラス
        $objCustomer = new SC_Customer_Ex();

        if ($objCustomer->isLoginSuccess() === true) {
            //お気に入りボタン表示
            $this->tpl_login = true;
        }

        // 基本情報を渡す
        $objSiteInfo = SC_Helper_DB_Ex::sfGetBasisData();
        $this->arrInfo = $objSiteInfo->data;

        //ランキング商品表示
        $this->arrBestProducts = $this->lfGetRanking();


    }

    /**
     * ランキング商品検索.
     *
     * @return array $arrBestProducts 検索結果配列
     */
    public function lfGetRanking(){
        $objQuery =& SC_Query_Ex::getSingletonInstance();
        $objProduct = new SC_Product_Ex();

        // ランキング商品取得
        $col = '*';
        $table = 'dtb_ranking';
        $objQuery->setOrder('rank');
        $objQuery->setLimit(RANKING_LIMIT);
        $arrBestProducts = $objQuery->select($col, $table, $where);

        $objQuery =& SC_Query_Ex::getSingletonInstance();
        if (count($arrBestProducts) > 0) {
            // 商品一覧を取得
            // where条件生成&セット
            $arrBestProductIds = array();
            $where = 'product_id IN (';
            foreach ($arrBestProducts as $key => $val) {
                $arrBestProductIds[] = $val['product_id'];
            }
            $where .= implode(', ', $arrBestProductIds);
            $where .= ')';
			$where .= ' AND ranking_mark = 1';
            $objQuery->setWhere($where);
            // 取得
            $arrTmp = $objProduct->lists($objQuery);
            foreach ($arrTmp as $key => $arrRow) {
                $arrProductList[$arrRow['product_id']] = $arrRow;
            }

            // 税込金額を設定する
            SC_Product_Ex::setIncTaxToProducts($arrProductList);

            // ランキング商品情報にマージ
            foreach (array_keys($arrBestProducts) as $key) {
                $arrRow =& $arrBestProducts[$key];
                if (isset($arrProductList[$arrRow['product_id']])) {
                    $arrRow = array_merge($arrRow, $arrProductList[$arrRow['product_id']]);
                } else {
                    // 削除済み商品は除外
                    unset($arrBestProducts[$key]);
                }
            }
        }
        return $arrBestProducts;
    }
}
